]> git.saurik.com Git - apt.git/blob - test/integration/framework
test: Fix apt-key tests to work with current gpg 2.1
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24 done
25 export MSGLEVEL="${MSGLEVEL:-3}"
26
27 # we all like colorful messages
28 if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
29 if [ ! -t 1 ]; then # but check that we output to a terminal
30 export MSGCOLOR='NO'
31 fi
32 fi
33
34
35 if [ "$MSGCOLOR" != 'NO' ]; then
36 CERROR="\033[1;31m" # red
37 CWARNING="\033[1;33m" # yellow
38 CMSG="\033[1;32m" # green
39 CINFO="\033[1;96m" # light blue
40 CDEBUG="\033[1;94m" # blue
41 CNORMAL="\033[0;39m" # default system console color
42 CDONE="\033[1;32m" # green
43 CPASS="\033[1;32m" # green
44 CFAIL="\033[1;31m" # red
45 CCMD="\033[1;35m" # pink
46 fi
47
48 msgprintf() {
49 local START="$1"
50 local MIDDLE="$2"
51 local END="$3"
52 shift 3
53 if [ -n "$1" ]; then
54 printf "$START " "$1"
55 shift
56 while [ -n "$1" ]; do
57 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
58 shift
59 done
60 fi
61 printf "${END}"
62 }
63 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
64 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
65 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
66 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
67 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
68 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
69 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
70 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
71 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
72 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
73 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
74 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
75 msgreportheader() {
76 if [ -n "$MSGTEST_MSG" ]; then
77 test "$1" != 'msgfailoutput' || echo
78 if [ -n "$MSGTEST_MSGMSG" ]; then
79 echo "$MSGTEST_MSGMSG"
80 fi
81 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
82 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
83 fi
84 echo -n "$MSGTEST_MSG"
85 unset MSGTEST_MSG
86 fi
87 }
88 msgskip() {
89 msgreportheader 'msgskip'
90 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
91 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
92 }
93 msgfail() {
94 msgreportheader 'msgfail'
95 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
96 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
97 if [ -n "$APT_DEBUG_TESTS" ]; then
98 runapt $SHELL
99 fi
100 EXIT_CODE=$((EXIT_CODE+1));
101 }
102 MSGGROUP_LEVEL=0
103 msggroup() {
104 if [ -n "$1" ]; then
105 if [ $MSGGROUP_LEVEL = 0 ]; then
106 MSGTEST_GRP='NEXT'
107 fi
108 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
109 else
110 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
111 if [ $MSGGROUP_LEVEL = 0 ]; then
112 unset MSGTEST_GRP
113 fi
114 fi
115 }
116
117 # enable / disable Debugging
118 if [ $MSGLEVEL -le 0 ]; then
119 msgdie() { true; }
120 fi
121 if [ $MSGLEVEL -le 1 ]; then
122 msgwarn() { true; }
123 msgnwarn() { true; }
124 fi
125 if [ $MSGLEVEL -le 2 ]; then
126 msgmsg() {
127 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
128 }
129 msgnmsg() { true; }
130 msgtest() {
131 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
132 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
133 MSGTEST_GRP="$MSGTEST_MSG"
134 fi
135 }
136 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
137 fi
138 if [ $MSGLEVEL -le 3 ]; then
139 msginfo() { true; }
140 msgninfo() { true; }
141 fi
142 if [ $MSGLEVEL -le 4 ]; then
143 msgdebug() { true; }
144 msgndebug() { true; }
145 fi
146 msgdone() {
147 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
148 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
149 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
150 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
151 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
152 true;
153 else
154 printf "${CDONE}DONE${CNORMAL}\n";
155 fi
156 }
157 getaptconfig() {
158 if [ -f ./aptconfig.conf ]; then
159 echo "$(readlink -f ./aptconfig.conf)"
160 elif [ -f ../aptconfig.conf ]; then
161 echo "$(readlink -f ../aptconfig.conf)"
162 elif [ -f ../../aptconfig.conf ]; then
163 echo "$(readlink -f ../../aptconfig.conf)"
164 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
165 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
166 fi
167 }
168 runapt() {
169 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
170 local CMD="$1"
171 shift
172 case "$CMD" in
173 sh|aptitude|*/*|command) ;;
174 *) CMD="${BUILDDIRECTORY}/$CMD";;
175 esac
176 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
177 }
178 aptconfig() { runapt apt-config "$@"; }
179 aptcache() { runapt apt-cache "$@"; }
180 aptcdrom() { runapt apt-cdrom "$@"; }
181 aptget() { runapt apt-get "$@"; }
182 aptftparchive() { runapt apt-ftparchive "$@"; }
183 aptkey() { runapt apt-key "$@"; }
184 aptmark() { runapt apt-mark "$@"; }
185 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
186 apt() { runapt apt "$@"; }
187 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
188 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
189 aptitude() { runapt aptitude "$@"; }
190 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
191 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
192 aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
193
194 dpkg() {
195 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
196 }
197 dpkgcheckbuilddeps() {
198 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
199 }
200 gdb() {
201 local CMD
202 case "$1" in
203 aptget) CMD="apt-get";;
204 aptcache) CMD="apt-cache";;
205 aptcdrom) CMD="apt-cdrom";;
206 aptconfig) CMD="apt-config";;
207 aptmark) CMD="apt-mark";;
208 apthelper) CMD="apt-helper";;
209 aptftparchive) CMD="apt-ftparchive";;
210 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
211 *) CMD="$1";;
212 esac
213 shift
214 if [ "${CMD##*/}" = "$CMD" ]; then
215 CMD="${BUILDDIRECTORY}/${CMD}"
216 fi
217 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
218 }
219
220 exitwithstatus() {
221 # error if we about to overflow, but ...
222 # "255 failures ought to be enough for everybody"
223 if [ $EXIT_CODE -gt 255 ]; then
224 msgdie "Total failure count $EXIT_CODE too big"
225 fi
226 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
227 }
228
229 shellsetedetector() {
230 local exit_status=$?
231 if [ "$exit_status" != '0' ]; then
232 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
233 if [ "$EXIT_CODE" = '0' ]; then
234 EXIT_CODE="$exit_status"
235 fi
236 fi
237 }
238
239 addtrap() {
240 if [ "$1" = 'prefix' ]; then
241 CURRENTTRAP="$2 $CURRENTTRAP"
242 else
243 CURRENTTRAP="$CURRENTTRAP $1"
244 fi
245 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
246 }
247
248 escape_shell() {
249 echo "$@" | sed -e "s#'#'\"'\"'#g"
250 }
251
252 setupenvironment() {
253 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
254 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
255 unset TMPDIR
256 fi
257 TMPWORKINGDIRECTORY="$(mktemp -d)"
258 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
259 if [ -n "$TMPDIR_ADD" ]; then
260 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
261 mkdir -p "$TMPWORKINGDIRECTORY"
262 unset TMPDIR_ADD
263 export TMPDIR="$TMPWORKINGDIRECTORY"
264 fi
265 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
266
267 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
268 if [ "$(id -u)" = '0' ]; then
269 # relax permissions so that running as root with user switching works
270 umask 022
271 chmod 711 "$TMPWORKINGDIRECTORY"
272 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
273 fi
274
275 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
276 # allow overriding the default BUILDDIR location
277 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
278 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}"
279 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}"
280 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}"
281 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
282 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}"
283 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}"
284 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}"
285 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
286 # -----
287
288 cd "$TMPWORKINGDIRECTORY"
289 mkdir rootdir aptarchive keys
290 cd rootdir
291 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
292 mkdir -p usr/bin var/cache var/lib var/log tmp
293 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
294 touch var/lib/dpkg/available
295 mkdir -p usr/lib/apt
296 ln -s "${METHODSDIR}" usr/lib/apt/methods
297 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
298 mkdir -p usr/lib/apt/solvers
299 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
300 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
301 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
302 fi
303 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
304 # system
305 if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then
306 ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
307 else
308 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
309 fi
310 cd ..
311 local BASENAME="${0##*/}"
312 local PACKAGESFILE="Packages-${BASENAME#*-}"
313 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
314 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
315 fi
316 local SOURCESSFILE="Sources-${BASENAME#*-}"
317 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
318 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
319 fi
320 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
321 chmod 644 keys/*
322 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
323
324 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
325 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
326 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
327 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
328 # either store apt-key were we can access it, even if we run it as a different user
329 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
330 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
331 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
332 # destroys coverage reporting though, so we disable changing user for the calling gpgv
333 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
334 if [ "$(id -u)" = '0' ]; then
335 echo 'Binary::gpgv::Debug::NoDropPrivs "true";' >>aptconfig.conf
336 fi
337
338 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
339 #!/bin/sh
340 set -e
341 if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
342 if [ -n "\$LD_LIBRARY_PATH" ]; then
343 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
344 else
345 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
346 fi
347 if [ -n "\$LD_PRELOAD" ]; then
348 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
349 else
350 export LD_PRELOAD="noopchroot.so"
351 fi
352 fi
353 EOF
354 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
355 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
356 exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
357 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
358 --force-not-root --force-bad-path "\$@"
359 EOF
360 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
361 exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
362 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
363 --force-not-root --force-bad-path "\$@"
364 EOF
365 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
366 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
367
368 {
369 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
370 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
371 fi
372 echo 'quiet "0";'
373 echo 'quiet::NoUpdate "true";'
374 echo 'quiet::NoStatistic "true";'
375 # too distracting for users, but helpful to detect changes
376 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
377 echo 'Acquire::Progress::Diffpercent "true";'
378 # in testcases, it can appear as if localhost has a rotation setup,
379 # hide this as we can't really deal with it properly
380 echo 'Acquire::Failure::ShowIP "false";'
381 # fakeroot can't fake everything, so disabled in production but good for tests
382 echo 'APT::Sandbox::Verify "true";'
383 } >> aptconfig.conf
384
385 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
386 if [ "$(id -u)" = '0' ]; then
387 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
388 fi
389 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
390 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
391 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
392 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
393 confighashes 'SHA1' # these are tests, not security best-practices
394
395 # create some files in /tmp and look at user/group to get what this means
396 TEST_DEFAULT_USER="$(id -un)"
397 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
398 TEST_DEFAULT_GROUP='root'
399 else
400 TEST_DEFAULT_GROUP="$(id -gn)"
401 fi
402
403 # cleanup the environment a bit
404 # prefer our apt binaries over the system apt binaries
405 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
406 export LC_ALL=C.UTF-8
407 unset LANGUAGE APT_CONFIG
408 unset GREP_OPTIONS DEB_BUILD_PROFILES
409 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
410 msgdone "info"
411 }
412
413 getarchitecture() {
414 if [ "$1" = "native" -o -z "$1" ]; then
415 eval `aptconfig shell ARCH APT::Architecture`
416 if [ -n "$ARCH" ]; then
417 echo $ARCH
418 else
419 dpkg --print-architecture
420 fi
421 else
422 echo $1
423 fi
424 }
425
426 getarchitectures() {
427 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
428 }
429
430 getarchitecturesfromcommalist() {
431 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
432 }
433
434 configarchitecture() {
435 {
436 echo "APT::Architecture \"$(getarchitecture $1)\";"
437 while [ -n "$1" ]; do
438 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
439 shift
440 done
441 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
442 configdpkg
443 }
444
445 configdpkg() {
446 if [ ! -e rootdir/var/lib/dpkg/status ]; then
447 local BASENAME="${0##*/}"
448 local STATUSFILE="status-${BASENAME#*-}"
449 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
450 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
451 else
452 echo -n > rootdir/var/lib/dpkg/status
453 fi
454 fi
455 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
456 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
457 local ARCHS="$(getarchitectures)"
458 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
459 DPKGARCH="$(dpkg --print-architecture)"
460 for ARCH in ${ARCHS}; do
461 if [ "${ARCH}" != "${DPKGARCH}" ]; then
462 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
463 # old-style used e.g. in Ubuntu-P – and as it seems travis
464 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
465 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
466 fi
467 fi
468 done
469 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
470 # dpkg doesn't really check the version as long as it is fully installed,
471 # but just to be sure we choose one above the required version
472 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
473 fi
474 fi
475 fi
476 }
477
478 configdpkgnoopchroot() {
479 # create a library to noop chroot() and rewrite maintainer script executions
480 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
481 # chroot directory dpkg could chroot into to execute the maintainer scripts
482 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
483 cat > noopchroot.c << EOF
484 #define _GNU_SOURCE
485 #include <stdio.h>
486 #include <stdlib.h>
487 #include <string.h>
488 #include <dlfcn.h>
489
490 static char * chrootdir = NULL;
491
492 int chroot(const char *path) {
493 printf("WARNING: CHROOTing to %s was ignored!\n", path);
494 free(chrootdir);
495 chrootdir = strdup(path);
496 return 0;
497 }
498 int execvp(const char *file, char *const argv[]) {
499 static int (*func_execvp) (const char *, char * const []) = NULL;
500 if (func_execvp == NULL)
501 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
502 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
503 return func_execvp(file, argv);
504 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
505 char *newfile;
506 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
507 perror("asprintf");
508 return -1;
509 }
510 char const * const baseadmindir = "/var/lib/dpkg";
511 char *admindir;
512 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
513 perror("asprintf");
514 return -1;
515 }
516 setenv("DPKG_ADMINDIR", admindir, 1);
517 return func_execvp(newfile, argv);
518 }
519 EOF
520 testsuccess --nomsg gcc -Wall -fPIC -shared -o noopchroot.so noopchroot.c -ldl
521 }
522 configcompression() {
523 local CMD='apthelper cat-file -C'
524 while [ -n "$1" ]; do
525 case "$1" in
526 '.') printf ".\t.\tcat\n";;
527 'gz') printf "gzip\tgz\t$CMD $1\n";;
528 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
529 *) printf "$1\t$1\t$CMD $1\n";;
530 esac
531 shift
532 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
533 }
534 confighashes() {
535 {
536 echo 'APT::FTPArchive {'
537 {
538 while [ -n "$1" ]; do
539 printf "$1" | tr 'a-z' 'A-Z'
540 printf "\t\"true\";\n"
541 shift
542 done
543 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
544 printf "$h\t\"false\";\n"
545 done
546 } | awk '!x[$1]++'
547 echo '};'
548 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
549 }
550 forcecompressor() {
551 COMPRESSOR="$1"
552 COMPRESS="$1"
553 COMPRESSOR_CMD="apthelper cat-file -C $1"
554 case $COMPRESSOR in
555 gzip) COMPRESS='gz';;
556 bzip2) COMPRESS='bz2';;
557 esac
558 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
559 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
560 Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
561 }
562
563 setupsimplenativepackage() {
564 local NAME="$1"
565 local ARCH="$2"
566 local VERSION="$3"
567 local RELEASE="${4:-unstable}"
568 local DEPENDENCIES="$5"
569 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
570 If you find such a package installed on your system,
571 something went horribly wrong! They are autogenerated
572 und used only by testcases and serve no other purpose…"}"
573
574 local SECTION="${7:-others}"
575 local DISTSECTION
576 if [ "$SECTION" = "${SECTION#*/}" ]; then
577 DISTSECTION="main"
578 else
579 DISTSECTION="${SECTION%/*}"
580 fi
581 local BUILDDIR=incoming/${NAME}-${VERSION}
582 mkdir -p ${BUILDDIR}/debian/source
583 cd ${BUILDDIR}
584 echo "* most suckless software product ever" > FEATURES
585 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
586 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
587
588 * Initial release
589
590 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
591 test -e debian/control || echo "Source: $NAME
592 Section: $SECTION
593 Priority: optional
594 Maintainer: Joe Sixpack <joe@example.org>
595 Build-Depends: debhelper (>= 7)
596 Standards-Version: 3.9.1
597
598 Package: $NAME" > debian/control
599 if [ "$ARCH" = 'all' ]; then
600 echo "Architecture: all" >> debian/control
601 else
602 echo "Architecture: any" >> debian/control
603 fi
604 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
605 echo "Description: $DESCRIPTION" >> debian/control
606
607 test -e debian/compat || echo "7" > debian/compat
608 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
609 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
610 cd - > /dev/null
611 }
612
613 buildsimplenativepackage() {
614 local NAME="$1"
615 local NM
616 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
617 NM="$(echo "$NAME" | cut -c 1-4)"
618 else
619 NM="$(echo "$NAME" | cut -c 1)"
620 fi
621 local ARCH="$2"
622 local VERSION="$3"
623 local RELEASE="${4:-unstable}"
624 local DEPENDENCIES="$5"
625 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
626 If you find such a package installed on your system,
627 something went horribly wrong! They are autogenerated
628 und used only by testcases and serve no other purpose…"}"
629
630 local SECTION="${7:-others}"
631 local PRIORITY="${8:-optional}"
632 local FILE_TREE="$9"
633 local COMPRESS_TYPE="${10:-gzip}"
634 local DISTSECTION
635 if [ "$SECTION" = "${SECTION#*/}" ]; then
636 DISTSECTION="main"
637 else
638 DISTSECTION="${SECTION%/*}"
639 fi
640 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
641
642 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
643 mkdir -p "$BUILDDIR/debian/source"
644 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
645 echo "#!/bin/sh
646 echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
647
648 echo "Copyleft by Joe Sixpack $(date +%Y)" > "${BUILDDIR}/debian/copyright"
649 echo "$NAME ($VERSION) $RELEASE; urgency=low
650
651 * Initial release
652
653 -- Joe Sixpack <joe@example.org> $(date -R)" > "${BUILDDIR}/debian/changelog"
654 {
655 echo "Source: $NAME
656 Priority: $PRIORITY
657 Maintainer: Joe Sixpack <joe@example.org>
658 Standards-Version: 3.9.3"
659 if [ "$SECTION" != '<none>' ]; then
660 echo "Section: $SECTION"
661 fi
662 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
663 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
664 echo "
665 Package: $NAME"
666
667 if [ "$ARCH" = 'all' ]; then
668 echo "Architecture: all"
669 else
670 echo "Architecture: any"
671 fi
672 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
673 test -z "$DEPS" || echo "$DEPS"
674 echo "Description: $DESCRIPTION"
675 } > "${BUILDDIR}/debian/control"
676
677 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
678 cd "${BUILDDIR}/.."
679 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
680 cd - >/dev/null
681 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
682 | while read SRC; do
683 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
684 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
685 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
686 # adv --yes --default-key 'Joe Sixpack' \
687 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
688 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
689 # fi
690 done
691
692 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
693 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
694 rm -rf "${BUILDDIR}/debian/tmp"
695 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
696 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
697 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
698 if [ -n "$FILE_TREE" ]; then
699 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
700 fi
701
702 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
703 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
704 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
705 # ensure the right permissions as dpkg-deb insists
706 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
707 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
708 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
709 done
710
711 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
712 mkdir -p "$CHANGEPATH"
713 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
714 rm -rf "${BUILDDIR}"
715 msgdone "info"
716 }
717
718 buildpackage() {
719 local BUILDDIR=$1
720 local RELEASE=$2
721 local SECTION=$3
722 local ARCH=$(getarchitecture $4)
723 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
724 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
725 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
726 cd "$BUILDDIR"
727 if [ "$ARCH" = "all" ]; then
728 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
729 fi
730 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
731 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
732 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
733 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
734 cd - > /dev/null
735 for PKG in $PKGS; do
736 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
737 done
738 for SRC in $SRCS; do
739 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
740 done
741 }
742
743 buildaptarchive() {
744 if [ -d incoming ]; then
745 buildaptarchivefromincoming "$@"
746 else
747 buildaptarchivefromfiles "$@"
748 fi
749 }
750
751 createaptftparchiveconfig() {
752 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
753 local COMPRESSORS="${COMPRESSORS%* }"
754 local ARCHS="$(getarchitectures)"
755 cat > ftparchive.conf <<EOF
756 Dir {
757 ArchiveDir "$(readlink -f .)";
758 CacheDir "$(readlink -f ..)";
759 FileListDir "$(readlink -f pool/)";
760 };
761 Default {
762 Packages::Compress "$COMPRESSORS";
763 Sources::Compress "$COMPRESSORS";
764 Contents::Compress "$COMPRESSORS";
765 Translation::Compress "$COMPRESSORS";
766 LongDescription "false";
767 };
768 TreeDefault {
769 Directory "pool/";
770 SrcDirectory "pool/";
771 };
772 EOF
773 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
774 cat <<EOF
775 tree "dists/$DIST" {
776 Architectures "$ARCHS all source";
777 FileList "${DIST}.\$(SECTION).pkglist";
778 SourceFileList "${DIST}.\$(SECTION).srclist";
779 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
780 };
781 EOF
782 done >> ftparchive.conf
783 }
784
785 buildaptftparchivedirectorystructure() {
786 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
787 for DIST in $DISTS; do
788 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
789 for SECTION in $SECTIONS; do
790 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
791 for ARCH in $ARCHS; do
792 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
793 done
794 mkdir -p "dists/${DIST}/${SECTION}/source"
795 mkdir -p "dists/${DIST}/${SECTION}/i18n"
796 done
797 done
798 }
799
800 insertpackage() {
801 local RELEASES="$1"
802 local NAME="$2"
803 local ARCH="$3"
804 local VERSION="$4"
805 local DEPENDENCIES="$5"
806 local PRIORITY="${6:-optional}"
807 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
808 If you find such a package installed on your system,
809 something went horribly wrong! They are autogenerated
810 und used only by testcases and serve no other purpose…"}"
811 local ARCHS=""
812 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
813 if [ "$RELEASE" = 'installed' ]; then
814 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
815 continue
816 fi
817 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
818 if [ "$arch" = 'none' ]; then
819 ARCHS="$(getarchitectures)"
820 else
821 ARCHS="$arch"
822 fi
823 for BUILDARCH in $ARCHS; do
824 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
825 mkdir -p "$PPATH"
826 {
827 echo "Package: $NAME
828 Priority: $PRIORITY
829 Section: other
830 Installed-Size: 42
831 Maintainer: Joe Sixpack <joe@example.org>"
832 test "$arch" = 'none' || echo "Architecture: $arch"
833 echo "Version: $VERSION
834 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
835 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES"
836 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
837 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
838 echo
839 } >> "${PPATH}/Packages"
840 done
841 done
842 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
843 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
844 echo "Package: $NAME
845 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
846 Description-en: $DESCRIPTION
847 " >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
848 done
849 }
850
851 insertsource() {
852 local RELEASES="$1"
853 local NAME="$2"
854 local ARCH="$3"
855 local VERSION="$4"
856 local DEPENDENCIES="$5"
857 local BINARY="${6:-$NAME}"
858 local ARCHS=""
859 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
860 local SPATH="aptarchive/dists/${RELEASE}/main/source"
861 mkdir -p $SPATH
862 local FILE="${SPATH}/Sources"
863 local DSCFILE="${NAME}_${VERSION}.dsc"
864 local TARFILE="${NAME}_${VERSION}.tar.gz"
865 echo "Package: $NAME
866 Binary: $BINARY
867 Version: $VERSION
868 Maintainer: Joe Sixpack <joe@example.org>
869 Architecture: $ARCH" >> $FILE
870 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
871 echo "Files:
872 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
873 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
874 Checksums-Sha256:
875 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
876 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
877 " >> "$FILE"
878 done
879 }
880
881 insertinstalledpackage() {
882 local NAME="$1"
883 local ARCH="$2"
884 local VERSION="$3"
885 local DEPENDENCIES="$4"
886 local PRIORITY="${5:-optional}"
887 local STATUS="${6:-install ok installed}"
888 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
889 If you find such a package installed on your system,
890 something went horribly wrong! They are autogenerated
891 und used only by testcases and serve no other purpose…"}"
892
893 local FILE='rootdir/var/lib/dpkg/status'
894 local INFO='rootdir/var/lib/dpkg/info'
895 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
896 echo "Package: $NAME
897 Status: $STATUS
898 Priority: $PRIORITY
899 Section: other
900 Installed-Size: 42
901 Maintainer: Joe Sixpack <joe@example.org>
902 Version: $VERSION" >> "$FILE"
903 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
904 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
905 echo "Description: $DESCRIPTION" >> "$FILE"
906 echo >> "$FILE"
907 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
908 echo -n > "${INFO}/${NAME}:${arch}.list"
909 else
910 echo -n > "${INFO}/${NAME}.list"
911 fi
912 done
913 }
914
915
916 buildaptarchivefromincoming() {
917 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
918 cd aptarchive
919 [ -e pool ] || ln -s ../incoming pool
920 [ -e ftparchive.conf ] || createaptftparchiveconfig
921 [ -e dists ] || buildaptftparchivedirectorystructure
922 msgninfo "\tGenerate Packages, Sources and Contents files… "
923 testsuccess aptftparchive generate ftparchive.conf
924 cd - > /dev/null
925 msgdone "info"
926 generatereleasefiles "$@"
927 }
928
929 buildaptarchivefromfiles() {
930 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
931 local DIR='aptarchive'
932 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
933 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
934 msgninfo "\t${line} file"
935 compressfile "$line" "$1"
936 msgdone "info"
937 done
938 generatereleasefiles "$@"
939 }
940
941 compressfile() {
942 cat "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | while read compressor extension command; do
943 if [ "$compressor" = '.' ]; then
944 if [ -n "$2" ]; then
945 touch -d "$2" "$1"
946 fi
947 continue
948 fi
949 cat "$1" | $command > "${1}.${extension}"
950 if [ -n "$2" ]; then
951 touch -d "$2" "${1}.${extension}"
952 fi
953 done
954 }
955
956 # can be overridden by testcases for their pleasure
957 getcodenamefromsuite() {
958 case "$1" in
959 unstable) echo 'sid';;
960 *) echo -n "$1";;
961 esac
962 }
963 getreleaseversionfromsuite() { true; }
964 getlabelfromsuite() { true; }
965 getoriginfromsuite() { true; }
966 getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
967
968 aptftparchiverelease() {
969 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
970 }
971 generatereleasefiles() {
972 # $1 is the Date header and $2 is the ValidUntil header to be set
973 # both should be given in notation date/touch can understand
974 local DATE="$1"
975 local VALIDUNTIL="$2"
976 if [ -e aptarchive/dists ]; then
977 msgninfo "\tGenerate Release files for dists… "
978 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
979 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
980 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
981 local CODENAME="$(getcodenamefromsuite $SUITE)"
982 local VERSION="$(getreleaseversionfromsuite $SUITE)"
983 local LABEL="$(getlabelfromsuite $SUITE)"
984 local ORIGIN="$(getoriginfromsuite $SUITE)"
985 aptftparchiverelease "$dir" \
986 -o APT::FTPArchive::Release::Suite="${SUITE}" \
987 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
988 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
989 -o APT::FTPArchive::Release::Label="${LABEL}" \
990 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
991 -o APT::FTPArchive::Release::Version="${VERSION}" \
992 > "$dir/Release"
993 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
994 sed -i '/^Date: / a\
995 NotAutomatic: yes' "$dir/Release"
996 fi
997 done
998 else
999 msgninfo "\tGenerate Release files for flat… "
1000 aptftparchiverelease ./aptarchive > aptarchive/Release
1001 fi
1002 if [ -n "$DATE" -a "$DATE" != "now" ]; then
1003 for release in $(find ./aptarchive -name 'Release'); do
1004 sed -i "s/^Date: .*$/Date: $(date -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release"
1005 touch -d "$DATE" "$release"
1006 done
1007 fi
1008 if [ -n "$VALIDUNTIL" ]; then
1009 sed -i "/^Date: / a\
1010 Valid-Until: $(date -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
1011 fi
1012 msgdone "info"
1013 }
1014
1015 setupdistsaptarchive() {
1016 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1017 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1018 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1019 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
1020 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
1021 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}"
1022 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1023 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
1024 msgdone "info"
1025 done
1026 }
1027
1028 setupflataptarchive() {
1029 local APTARCHIVE="$(readlink -f ./aptarchive)"
1030 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1031 if [ -f "${APTARCHIVE}/Packages" ]; then
1032 msgninfo "\tadd deb sources.list line… "
1033 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1034 msgdone 'info'
1035 else
1036 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1037 fi
1038 if [ -f "${APTARCHIVE}/Sources" ]; then
1039 msgninfo "\tadd deb-src sources.list line… "
1040 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1041 msgdone 'info'
1042 else
1043 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1044 fi
1045 }
1046
1047 setupaptarchive() {
1048 local NOUPDATE=0
1049 if [ "$1" = '--no-update' ]; then
1050 NOUPDATE=1
1051 shift
1052 fi
1053 buildaptarchive "$@"
1054 if [ -e aptarchive/dists ]; then
1055 setupdistsaptarchive
1056 else
1057 setupflataptarchive
1058 fi
1059 signreleasefiles 'Joe Sixpack'
1060 if [ "1" != "$NOUPDATE" ]; then
1061 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
1062 fi
1063 }
1064
1065 signreleasefiles() {
1066 local SIGNER="${1:-Joe Sixpack}"
1067 local REPODIR="${2:-aptarchive}"
1068 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
1069 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
1070 msgninfo "\tSign archive with $SIGNER key $KEY"
1071 local REXKEY='keys/rexexpired'
1072 local SECEXPIREBAK="${REXKEY}.sec.bak"
1073 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1074 if [ "${SIGNER}" = 'Rex Expired' ]; then
1075 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1076 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1077 # therefore we 'temporary' make the key not expired and restore a backup after signing
1078 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1079 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
1080 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1081 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1082 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1083 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1084 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
1085 else
1086 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1087 cat setexpire.gpg
1088 exit 1
1089 fi
1090 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1091 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
1092 fi
1093 fi
1094 for RELEASE in $(find "${REPODIR}/" -name Release); do
1095 testsuccess $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
1096 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
1097 testsuccess $GPG --default-key "$SIGNER" --clearsign --output "$INRELEASE" "$RELEASE"
1098 # we might have set a specific date for the Release file, so copy it
1099 touch -d "$(stat --format "%y" ${RELEASE})" "${RELEASE}.gpg" "${INRELEASE}"
1100 done
1101 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1102 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1103 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
1104 fi
1105 msgdone 'info'
1106 }
1107
1108 redatereleasefiles() {
1109 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1110 for release in $(find aptarchive/ -name 'Release'); do
1111 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1112 touch -d "$DATE" "$release"
1113 done
1114 signreleasefiles "${2:-Joe Sixpack}"
1115 }
1116
1117 webserverconfig() {
1118 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
1119 local NOCHECK=false
1120 if [ "$1" = '--no-check' ]; then
1121 NOCHECK=true
1122 shift
1123 fi
1124 local DOWNLOG='rootdir/tmp/download-testfile.log'
1125 local STATUS='downloaded/webserverconfig.status'
1126 rm -f "$STATUS" "$DOWNLOG"
1127 # very very basic URI encoding
1128 local URI
1129 if [ -n "$2" ]; then
1130 msgtest "Set webserver config option '${1}' to" "$2"
1131 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
1132 else
1133 msgtest 'Clear webserver config option' "${1}"
1134 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
1135 fi
1136 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
1137 msgpass
1138 else
1139 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1140 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1141 msgfailoutput '' "$OUTPUT"
1142 fi
1143 $NOCHECK || testwebserverlaststatuscode '200'
1144 }
1145
1146 rewritesourceslist() {
1147 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
1148 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
1149 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1150 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
1151 -e "s#http://localhost:${APTHTTPPORT}/#${1}#" \
1152 -e "s#https://localhost:${APTHTTPSPORT}/#${1}#"
1153 done
1154 }
1155
1156 # wait for up to 10s for a pid file to appear to avoid possible race
1157 # when a helper is started and dosn't write the PID quick enough
1158 waitforpidfile() {
1159 local PIDFILE="$1"
1160 for i in $(seq 10); do
1161 if test -s "$PIDFILE"; then
1162 return 0
1163 fi
1164 sleep 1
1165 done
1166 msgdie "waiting for $PIDFILE failed"
1167 return 1
1168 }
1169
1170 changetowebserver() {
1171 local REWRITE='no'
1172 if [ "$1" != '--no-rewrite' ]; then
1173 REWRITE='yes'
1174 else
1175 shift
1176 fi
1177 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
1178 cd aptarchive
1179 local LOG="webserver.log"
1180 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
1181 cat "$LOG"
1182 false
1183 fi
1184 waitforpidfile aptwebserver.pid
1185 local PID="$(cat aptwebserver.pid)"
1186 if [ -z "$PID" ]; then
1187 msgdie 'Could not fork aptwebserver successfully'
1188 fi
1189 addtrap "kill $PID;"
1190 waitforpidfile aptwebserver.port
1191 APTHTTPPORT="$(cat aptwebserver.port)"
1192 if [ -z "$APTHTTPPORT" ]; then
1193 msgdie 'Could not get port for aptwebserver successfully'
1194 fi
1195 cd - > /dev/null
1196 else
1197 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
1198 fi
1199 if [ "$REWRTE" != 'yes' ]; then
1200 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1201 fi
1202 }
1203
1204 changetohttpswebserver() {
1205 if ! command -v stunnel4 >/dev/null 2>&1; then
1206 msgdie 'You need to install stunnel4 for https testcases'
1207 fi
1208 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1209 changetowebserver --no-rewrite "$@"
1210 fi
1211 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1212 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1213 output = /dev/null
1214
1215 [https]
1216 accept = 0
1217 connect = $APTHTTPPORT
1218 " > "${TMPWORKINGDIRECTORY}/stunnel.conf"
1219 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1220 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1221 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
1222 if [ -z "$PID" ]; then
1223 msgdie 'Could not fork stunnel4 successfully'
1224 fi
1225 addtrap 'prefix' "kill ${PID};"
1226 APTHTTPSPORT="$(lsof -i | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
1227 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1228 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
1229 }
1230
1231 changetocdrom() {
1232 mkdir -p rootdir/media/cdrom/.disk
1233 local CD="$(readlink -f rootdir/media/cdrom)"
1234 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1235 acquire::cdrom::mount "${CD}";
1236 acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1237 acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1238 acquire::cdrom::autodetect 0;
1239 EOF
1240 echo -n "$1" > "${CD}/.disk/info"
1241 if [ ! -d aptarchive/dists ]; then
1242 msgdie 'Flat file archive cdroms can not be created currently'
1243 return 1
1244 fi
1245 mv aptarchive/dists "$CD"
1246 ln -s "$(readlink -f ./incoming)" "$CD/pool"
1247 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1248 # start with an unmounted disk
1249 mv "${CD}" "${CD}-unmounted"
1250 # we don't want the disk to be modifiable
1251 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
1252 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1253 }
1254
1255 downloadfile() {
1256 local PROTO="${1%%:*}"
1257 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
1258 download-file "$1" "$2" "$3" 2>&1 ; then
1259 return 1
1260 fi
1261 # only if the file exists the download was successful
1262 if [ -r "$2" ]; then
1263 return 0
1264 else
1265 return 1
1266 fi
1267 }
1268
1269 checkdiff() {
1270 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1271 if [ -n "$DIFFTEXT" ]; then
1272 echo >&2
1273 echo >&2 "$DIFFTEXT"
1274 return 1
1275 else
1276 return 0
1277 fi
1278 }
1279
1280 testoutputequal() {
1281 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1282 local COMPAREFILE="$1"
1283 shift
1284 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
1285 msgpass
1286 else
1287 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1288 cat "$COMPAREFILE" >>"${OUTPUT}"
1289 msgfailoutput '' "$OUTPUT" "$@"
1290 fi
1291 }
1292
1293 testfileequal() {
1294 msggroup 'testfileequal'
1295 local MSG='Test for correctness of file'
1296 if [ "$1" = '--nomsg' ]; then
1297 MSG=''
1298 shift
1299 fi
1300 local FILE="$1"
1301 shift
1302 if [ -n "$MSG" ]; then
1303 msgtest "$MSG" "$FILE"
1304 fi
1305 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
1306 if [ -z "$*" ]; then
1307 testoutputequal "$FILE" echo -n ''
1308 else
1309 testoutputequal "$FILE" echo "$*"
1310 fi
1311 msggroup
1312 }
1313
1314 testempty() {
1315 msggroup 'testempty'
1316 msgtest "Test for no output of" "$*"
1317 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1318 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test ! -s "$COMPAREFILE"; then
1319 msgpass
1320 else
1321 msgfailoutput '' "$COMPAREFILE" "$@"
1322 fi
1323 aptautotest 'testempty' "$@"
1324 msggroup
1325 }
1326 testnotempty() {
1327 msggroup 'testnotempty'
1328 msgtest "Test for some output of" "$*"
1329 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1330 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1331 msgpass
1332 else
1333 msgfailoutput '' "$COMPAREFILE" "$@"
1334 fi
1335 aptautotest 'testnotempty' "$@"
1336 msggroup
1337 }
1338
1339 testequal() {
1340 msggroup 'testequal'
1341 local MSG='Test of equality of'
1342 if [ "$1" = '--nomsg' ]; then
1343 MSG=''
1344 shift
1345 fi
1346
1347 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1348 echo "$1" > "$COMPAREFILE"
1349 shift
1350
1351 if [ -n "$MSG" ]; then
1352 msgtest "$MSG" "$*"
1353 fi
1354 testoutputequal "$COMPAREFILE" "$@"
1355 aptautotest 'testequal' "$@"
1356 msggroup
1357 }
1358
1359 testequalor2() {
1360 msggroup 'testequalor2'
1361 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1362 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1363 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1364 echo "$1" > "$COMPAREFILE1"
1365 echo "$2" > "$COMPAREFILE2"
1366 shift 2
1367 msgtest "Test for equality OR of" "$*"
1368 "$@" >"$COMPAREAGAINST" 2>&1 || true
1369 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1370 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
1371 then
1372 msgpass
1373 else
1374 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1375 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1376 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1377 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1378 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1379 msgfailoutput '' "$OUTPUT"
1380 fi
1381 aptautotest 'testequalor2' "$@"
1382 msggroup
1383 }
1384
1385 testshowvirtual() {
1386 msggroup 'testshowvirtual'
1387 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1388 local PACKAGE="$1"
1389 shift
1390 while [ -n "$1" ]; do
1391 VIRTUAL="${VIRTUAL}
1392 N: Can't select versions from package '$1' as it is purely virtual"
1393 PACKAGE="${PACKAGE} $1"
1394 shift
1395 done
1396 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1397 VIRTUAL="${VIRTUAL}
1398 N: No packages found"
1399 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1400 local ARCH="$(getarchitecture 'native')"
1401 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1402 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
1403 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
1404 msggroup
1405 }
1406
1407 testnopackage() {
1408 msggroup 'testnopackage'
1409 msgtest "Test for non-existent packages" "apt-cache show $*"
1410 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1411 if [ -n "$SHOWPKG" ]; then
1412 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1413 echo "$SHOWPKG" >"$OUTPUT"
1414 msgfailoutput '' "$OUTPUT"
1415 else
1416 msgpass
1417 fi
1418 msggroup
1419 }
1420 testnosrcpackage() {
1421 msggroup 'testnosrcpackage'
1422 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1423 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1424 if [ -n "$SHOWPKG" ]; then
1425 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1426 echo "$SHOWPKG" >"$OUTPUT"
1427 msgfailoutput '' "$OUTPUT"
1428 else
1429 msgpass
1430 fi
1431 msggroup
1432 }
1433
1434 testdpkgstatus() {
1435 msggroup 'testdpkgstatus'
1436 local STATE="$1"
1437 local NR="$2"
1438 shift 2
1439 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1440 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1441 if [ "$PKGS" != $NR ]; then
1442 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1443 echo "$PKGS" >"$OUTPUT"
1444 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1445 msgfailoutput '' "$OUTPUT"
1446 else
1447 msgpass
1448 fi
1449 msggroup
1450 }
1451
1452 testdpkginstalled() {
1453 msggroup 'testdpkginstalled'
1454 testdpkgstatus 'ii' "$#" "$@"
1455 msggroup
1456 }
1457
1458 testdpkgnotinstalled() {
1459 msggroup 'testdpkgnotinstalled'
1460 testdpkgstatus 'ii' '0' "$@"
1461 msggroup
1462 }
1463
1464 testmarkedauto() {
1465 msggroup 'testmarkedauto'
1466 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1467 if [ -n "$1" ]; then
1468 msgtest 'Test for correctly marked as auto-installed' "$*"
1469 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
1470 else
1471 msgtest 'Test for correctly marked as auto-installed' 'no package'
1472 echo -n > "$COMPAREFILE"
1473 fi
1474 testoutputequal "$COMPAREFILE" aptmark showauto
1475 msggroup
1476 }
1477 testmarkedmanual() {
1478 msggroup 'testmarkedmanual'
1479 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1480 if [ -n "$1" ]; then
1481 msgtest 'Test for correctly marked as manually installed' "$*"
1482 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
1483 else
1484 msgtest 'Test for correctly marked as manually installed' 'no package'
1485 echo -n > "$COMPAREFILE"
1486 fi
1487 testoutputequal "$COMPAREFILE" aptmark showmanual
1488 msggroup
1489 }
1490
1491 msgfailoutput() {
1492 msgreportheader 'msgfailoutput'
1493 local MSG="$1"
1494 local OUTPUT="$2"
1495 shift 2
1496 if [ "$1" = 'grep' ]; then
1497 echo >&2
1498 while [ -n "$2" ]; do shift; done
1499 echo "#### Complete file: $1 ####"
1500 cat >&2 "$1" || true
1501 echo '#### grep output ####'
1502 elif [ "$1" = 'test' ]; then
1503 echo >&2
1504 # doesn't support ! or non-file flags
1505 msgfailoutputstatfile() {
1506 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1507 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1508 echo "#### stat(2) of file: $2 ####"
1509 stat "$2" || true
1510 if test -d "$2"; then
1511 echo "#### The directory contains: $2 ####"
1512 ls >&2 "$2" || true
1513 elif test -e "$2"; then
1514 echo "#### Complete file: $2 ####"
1515 cat >&2 "$2" || true
1516 fi
1517 fi
1518 }
1519 msgfailoutputstatfile "$2" "$3"
1520 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1521 shift 3
1522 msgfailoutputstatfile "$2" "$3"
1523 done
1524 echo '#### test output ####'
1525 elif [ "$1" = 'cmp' ]; then
1526 echo >&2
1527 while [ -n "$2" ]; do
1528 echo "#### Complete file: $2 ####"
1529 cat >&2 "$2" || true
1530 shift
1531 done
1532 echo '#### cmp output ####'
1533 fi
1534 cat >&2 "$OUTPUT"
1535 msgfail "$MSG"
1536 }
1537
1538 testsuccesswithglobalerror() {
1539 local TYPE="$1"
1540 local ERRORS="$2"
1541 shift 2
1542 msggroup "$TYPE"
1543 if [ "$1" = '--nomsg' ]; then
1544 shift
1545 else
1546 msgtest 'Test for successful execution of' "$*"
1547 fi
1548 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
1549 if "$@" >"${OUTPUT}" 2>&1; then
1550 if expr match "$1" '^apt.*' >/dev/null; then
1551 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1552 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1553 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
1554 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1555 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1556 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1557 msgpass
1558 else
1559 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1560 fi
1561 else
1562 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1563 fi
1564 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1565 if grep -q -E "^N: " "$OUTPUT"; then
1566 msgpass
1567 else
1568 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1569 fi
1570 else
1571 msgpass
1572 fi
1573 else
1574 msgpass
1575 fi
1576 else
1577 local EXITCODE=$?
1578 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1579 fi
1580 aptautotest "$TYPE" "$@"
1581 msggroup
1582 }
1583 testsuccesswithnotice() {
1584 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1585 }
1586 testsuccess() {
1587 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1588 }
1589 testwarning() {
1590 msggroup 'testwarning'
1591 if [ "$1" = '--nomsg' ]; then
1592 shift
1593 else
1594 msgtest 'Test for successful execution with warnings of' "$*"
1595 fi
1596 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1597 if "$@" >"${OUTPUT}" 2>&1; then
1598 if expr match "$1" '^apt.*' >/dev/null; then
1599 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1600 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1601 elif grep -q -E '^E: ' "$OUTPUT"; then
1602 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1603 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1604 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1605 else
1606 msgpass
1607 fi
1608 else
1609 msgpass
1610 fi
1611 else
1612 local EXITCODE=$?
1613 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1614 fi
1615 aptautotest 'testwarning' "$@"
1616 msggroup
1617 }
1618 testfailure() {
1619 msggroup 'testfailure'
1620 if [ "$1" = '--nomsg' ]; then
1621 shift
1622 else
1623 msgtest 'Test for failure in execution of' "$*"
1624 fi
1625 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1626 if "$@" >"${OUTPUT}" 2>&1; then
1627 local EXITCODE=$?
1628 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1629 else
1630 local EXITCODE=$?
1631 if expr match "$1" '^apt.*' >/dev/null; then
1632 if [ "$1" = 'aptkey' ]; then
1633 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1634 grep -q -E " BAD signature from " "$OUTPUT"; then
1635 msgpass
1636 else
1637 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1638 fi
1639 else
1640 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1641 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1642 elif grep -q -E '==ERROR' "$OUTPUT"; then
1643 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1644 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1645 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1646 else
1647 msgpass
1648 fi
1649 fi
1650 else
1651 msgpass
1652 fi
1653 fi
1654 aptautotest 'testfailure' "$@"
1655 msggroup
1656 }
1657
1658 testreturnstateequal() {
1659 local STATE="$1"
1660 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1661 local STATE="$2"
1662 local TYPE="$3"
1663 shift 3
1664 msggroup "${STATE}equal"
1665 if [ "$1" != '--nomsg' ]; then
1666 local CMP="$1"
1667 shift
1668 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1669 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1670 else
1671 local CMP="$2"
1672 shift 2
1673 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1674 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1675 fi
1676 else
1677 msggroup "${STATE}equal"
1678 if [ "$2" != '--nomsg' ]; then
1679 local CMP="$2"
1680 shift 2
1681 "$STATE" "$@"
1682 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1683 else
1684 local CMP="$3"
1685 shift 3
1686 "$STATE" --nomsg "$@"
1687 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1688 fi
1689 fi
1690 msggroup
1691 }
1692 testsuccessequal() {
1693 # we compare output, so we know perfectly well about N:
1694 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
1695 }
1696 testwarningequal() {
1697 testreturnstateequal 'testwarning' "$@"
1698 }
1699 testfailureequal() {
1700 testreturnstateequal 'testfailure' "$@"
1701 }
1702
1703 testfailuremsg() {
1704 msggroup 'testfailuremsg'
1705 local CMP="$1"
1706 shift
1707 testfailure "$@"
1708 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
1709 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
1710 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
1711 testoutputequal "$COMPAREFILE" echo "$CMP"
1712 msggroup
1713 }
1714 testwarningmsg() {
1715 msggroup 'testwarningmsg'
1716 local CMP="$1"
1717 shift
1718 testwarning "$@"
1719 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1720 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
1721 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
1722 testoutputequal "$COMPAREFILE" echo "$CMP"
1723 msggroup
1724 }
1725
1726 testfilestats() {
1727 msggroup 'testfilestats'
1728 msgtest "Test that file $1 has $2 $3" "$4"
1729 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1730 msgpass
1731 else
1732 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1733 {
1734 ls -ld "$1" || true
1735 echo -n "stat(1) reports for $2: "
1736 stat --format "$2" "$1" || true
1737 } >"$OUTPUT" 2>&1
1738 msgfailoutput '' "$OUTPUT"
1739 fi
1740 msggroup
1741 }
1742 testaccessrights() {
1743 msggroup 'testaccessrights'
1744 testfilestats "$1" '%a' '=' "$2"
1745 msggroup
1746 }
1747
1748 testwebserverlaststatuscode() {
1749 msggroup 'testwebserverlaststatuscode'
1750 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1751 local STATUS='downloaded/webserverstatus-statusfile.log'
1752 rm -f "$DOWNLOG" "$STATUS"
1753 msgtest 'Test last status code from the webserver was' "$1"
1754 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1755 msgpass
1756 else
1757 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1758 {
1759 if [ -n "$2" ]; then
1760 shift
1761 echo >&2 '#### Additionally provided output files contain:'
1762 cat >&2 "$@"
1763 fi
1764 echo >&2 '#### Download log of the status code:'
1765 cat >&2 "$DOWNLOG"
1766 } >"$OUTPUT" 2>&1
1767 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
1768 fi
1769 msggroup
1770 }
1771
1772 createlistofkeys() {
1773 local OUTPUT="$1"
1774 shift
1775 while [ -n "$1" ]; do
1776 # gpg 2.1.something starts printing [SC] at some point
1777 if grep -q ' rsa2048/' "$OUTPUT" && grep -qF '[SC]' "$OUTPUT"; then
1778 case "$1" in
1779 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1780 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [SC] [expired: 2013-07-13]';;
1781 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16 [SC]';;
1782 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19 [SC]';;
1783 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1784 *) echo 'UNKNOWN KEY';;
1785 esac
1786 # gpg 2.1 has a slightly different output format
1787 elif grep -q ' rsa2048/' "$OUTPUT"; then
1788 case "$1" in
1789 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1790 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1791 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';;
1792 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';;
1793 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1794 *) echo 'UNKNOWN KEY';;
1795 esac
1796 else
1797 case "$1" in
1798 *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1799 *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1800 *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';;
1801 oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';;
1802 newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1803 *) echo 'UNKNOWN KEY';;
1804 esac
1805 fi
1806 shift
1807 done
1808 }
1809 testaptkeys() {
1810 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
1811 if ! aptkey list | grep '^pub' > "$OUTPUT"; then
1812 echo -n > "$OUTPUT"
1813 fi
1814 testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")"
1815 }
1816
1817 pause() {
1818 echo "STOPPED execution. Press enter to continue"
1819 local IGNORE
1820 read IGNORE
1821 }
1822
1823 listcurrentlistsdirectory() {
1824 {
1825 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1826 stat --format '%U:%G:%a:%n' "$line"
1827 done
1828 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1829 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1830 done
1831 } | sort
1832 }
1833 forallsupportedcompressors() {
1834 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
1835 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
1836 "$@" "$COMP"
1837 done
1838 }
1839
1840 ### convenience hacks ###
1841 mkdir() {
1842 # creating some directories by hand is a tedious task, so make it look simple
1843 local PARAMS="$*"
1844 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
1845 # only the last directory created by mkdir is effected by the -m !
1846 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1847 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1848 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1849 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1850 if [ "$(id -u)" = '0' ]; then
1851 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1852 fi
1853 else
1854 command mkdir "$@"
1855 fi
1856 }
1857
1858 ### The following tests are run by most test methods automatically to check
1859 ### general things about commands executed without writing the test every time.
1860
1861 aptautotest() {
1862 local TESTCALL="$1"
1863 local CMD="$2"
1864 local FIRSTOPT="$3"
1865 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
1866 if command -v $AUTOTEST >/dev/null; then
1867 shift 3
1868 # save and restore the *.output files from other tests
1869 # as we might otherwise override them in these automatic tests
1870 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1871 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1872 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
1873 $AUTOTEST "$TESTCALL" "$@"
1874 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1875 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1876 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
1877 fi
1878 }
1879
1880 aptautotest_aptget_update() {
1881 local TESTCALL="$1"
1882 while [ -n "$2" ]; do
1883 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1884 shift
1885 done
1886 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1887 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1888 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1889 # all copied files are properly chmodded
1890 local backupIFS="$IFS"
1891 IFS="$(printf "\n\b")"
1892 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
1893 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1894 done
1895 IFS="$backupIFS"
1896 if [ "$TESTCALL" = 'testsuccess' ]; then
1897 # failure cases can retain partial files and such
1898 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1899 fi
1900 }
1901 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
1902 aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
1903
1904 testaptautotestnodpkgwarning() {
1905 local TESTCALL="$1"
1906 while [ -n "$2" ]; do
1907 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1908 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
1909 shift
1910 done
1911 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1912 }
1913
1914 aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1915 aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1916 aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1917 aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1918 aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1919 aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }